//	Copyright 2014 Ohtan's Design Corporation

//	*     *   ***   ******* *     *                                           
//	**   **  *   *     *    **    *                                           
//	* * * * *     *    *    * *   *                                           
//	*  *  * *     *    *    *  *  *                                           
//	*     * *******    *    *   * *                                           
//	*     * *     *    *    *    **                                           
//	*     * *     * ******* *     *                                           

// ===========================================================================
// =	CL^								 =
// ===========================================================================
//	009 2014.06.02				0.09
//	ELowerTemp,UpperTemp ̓͂̏ƁA𐧌
// ---------------------------------------------------------------------------
//	001 2014.05.24				0.01
//	EVK쐬 16F873A AZu[\[X XC8ֈڐA by A.Ohta
// ===========================================================================
// Timer0 ɂăC^[o^C} 2.5msec݂𔭐āA
// 7SEG-LED̃_Ci~bN_ȂB
// Timer2 ɂăC^[o^C} 10msec݂ʓrāA`^ȌƁA
// Pb^C~O𔭐āA`/cϊ̃^C~O𓾂B
// ***************************************************************************
// *	CN[ht@C						     *
// ***************************************************************************

	//	*****  *****
#include	<xc.h>

	//	***** 錾 *****


	//	*****  *****

#include	"device.h"		//	foCX
#include        "eeprom.h"

// ***************************************************************************
// *	Œl								   *
// ***************************************************************************

#define DIGOFF  0xE0                // all digit common off
#define Point   0xFE                // 7Seg-LED dicimal point
#define Relay   PORTAbits.RA5       // Relay output bit

// EEPROM Prim. Data Lower Temp. 16bit, Upper Temp. 16bit
// (Lower temp's Higher 8bit,Lower temp's Lower 8bit,Upper temp's Higher 8bit,Higher temp's Lower 8bit)
__EEPROM_DATA(0x01,0x0E,0x01,0x18,0x00,0x00,0x00,0x00);

// ***************************************************************************
// ***************************************************************************
// *	\								   *
// ***************************************************************************
// ***************************************************************************


// ***************************************************************************
// *	O[oϐ								*
// ***************************************************************************

unsigned char mode;
int Timer,Old_Time;
int Count;
unsigned char Digit;
unsigned int Temp, Disp;

// 7Seg-LED Datam for Display 0,1,2,3,4,5,6,7,8,9,A,B,C,D,E,F _
const unsigned char LED_SEG[16] = {0x81, 0xF3, 0x49, 0x61, 0x33, 0x25, 0x05, 0xF1, 0x01, 0x31,
                         0x11, 0x07, 0x8D, 0x43, 0x0D, 0x1D};

unsigned char now_SW1,old_SW1,change1;  // for escpae SW1's chattering
unsigned char now_SW2,old_SW2,change2;  // for escpae SW2's chattering
unsigned char now_SW3,old_SW3,change3;  // for escpae SW3's chattering
unsigned char now_SW4,old_SW4,change4;  // for escpae SW4's chattering

int LowerTemp,UpperTemp;

// ***************************************************************************
// *	e[u																 *
// ***************************************************************************


// ***************************************************************************
// *	}N錾																 *
// ***************************************************************************

#define Push_SW1 PORTCbits.RC0
#define Push_SW2 PORTCbits.RC1
#define Push_SW3 PORTCbits.RC2
#define Push_SW4 PORTCbits.RC3

// ***************************************************************************
// *	vg^Cv錾															 *
// ***************************************************************************

void	main(void);
void    interrupt isr(void);

// ***************************************************************************
// *	{																 *
// ***************************************************************************

//============================================================================
//	C
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	X^[gAbv[`̃Wv߂ŌĂяo܂B
//			{֐͖[vłAEo邱Ƃ͂܂B
//============================================================================
void	main(void)
{
	//	***** ͂߂ *****
	DevInit();															//	foCXݒ
        ADCON0 = 0x81;          // Fosc/32,CH0
        ADCON1 = 0x85;          // Right,Vref+ RA3,Vref- Vss,AN0.AN1L

	PORTC = 0x0E;		// S
	LED7Seg = 0x00;		// 

	OPTION_REG = 0x87;	// Timer0 (2.5msec ~ 1000)/0.05usec ~ 4 = 12,500 12,500/256 = 49
	TMR0 = 0xCF;		// init Set 256-49=207=0xCF(256 ̃AbvJE^[̈)

	T2CON = 0x7E;		// Timer2 1/16, 1/16 5MHz/256=51.2usec
	TMR2 = 195;		// set Timer2 51.2usec*195=10msec(ݒ萔lṽAbvJE^[̈)

	Timer = 10;		// \pJEgl̃Zbg
	Count = 100;		// 10msecJE^[@1bJEgplZbg
	Digit = 0;		// _Ci~bN\ptONA

	TMR0IE = 1;		// Timer0 荞݋
        TMR2IE = 1;		// Timer2 荞݋
	PEIE = 1;		// ӊ荞݋
	GIE = 1;		// O[o荞݋

	Old_Time = Timer;

        Disp = 0;

        change1 = 0;
        now_SW1 = 1;
        old_SW1 = now_SW1;

        change2 = 0;
        now_SW2 = 1;
        old_SW2 = now_SW2;

        change3 = 0;
        now_SW3 = 1;
        old_SW3 = now_SW3;

        change4 = 0;
        now_SW4 = 1;
        old_SW4 = now_SW4;

        mode = 0;

        // EEPROM ȑO̐ݒǂ݂
        LowerTemp = ((int)E2promRead(0x00) << 8) + (int)E2promRead(0x01);
        UpperTemp = ((int)E2promRead(0x02) << 8) + (int)E2promRead(0x03);
        
	while(1){
            if(Old_Time != Timer ){
                Old_Time = Timer;

                Temp = adc();
                if(mode == 0){
                    // A/DϊĺA4.0(V) = 50() = 1024 1024
                    Disp = (int)((float)Temp * 0.4883);
                    // [o͔ & o
                    if(Disp>UpperTemp) Relay = 1;
                    if(Disp<LowerTemp) Relay = 0;
                }
                if(mode == 1) Disp = LowerTemp;
                if(mode == 2) Disp = UpperTemp;
                    
            }
	}
}

//============================================================================
//	ݏ
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	SĂ݂̊ł̊֐Ă΂
//============================================================================
void interrupt isr(void)
{
	char disp,eeprom0,eeprom1,eeprom2,eeprom3;

        // Timer0  2.5msec C^[o^C}[ݏ
	if(TMR0IF){
		TMR0IF=0;       // clear interrupt flag
		TMR0 = 0xCF;    // reset Timer0 cunter

                // Dynamic Display 7SEG-LED
		switch(Digit){
			case 0: // in case of the 3rd digit
				Digit++;
				LEDCom = DIGOFF;                // US\
				disp = LED_SEG[Disp/100];       // S̈ʂ߂
				if( disp != 0x81 ){             // S̈ʂ[\Ȃ
                                    if(mode == 2) disp &= 0xFE; // xݒ莞ɂ́ARP^ڂɃhbg\
                                    LED7Seg = disp;             // 3ڂ̕\p^[Zbg
                                    LEDCom = DIG3;		// 3ڂ̂ݓ_
				}
				break;

			case 1: // in case of the 2nd digit
				Digit++;
				LEDCom = DIGOFF;
				LED7Seg = LED_SEG[(Disp%100)/10] & 0xFE;
                                LEDCom = DIG2;                  // 2ړ_I
				break;

			case 2: // in case of the 1st digit
				Digit = 0;
				LEDCom = DIGOFF;
				disp = LED_SEG[(Disp%100)%10];
                                if(mode == 1) disp &= 0xFE;
                                LED7Seg = disp;
                                LEDCom = DIG1;                  // 2ړ_I
				break;

			default:
				break;
		}
	}

        // Timer2 ́@10msec C^[o^C}[ݏ(`^ȌƁAPr̂`/cϊ^C~O
	if(TMR2IF){
		TMR2IF = 0;
		TMR2 = 195;

                now_SW1 = Push_SW1;                 // SW1 ǂݍ
                if(change1){                        // 10msecO̊荞ݎɕωH
                    change1 = 0;                    // ωtONA
                    if(old_SW1 != now_SW1){         // ω肵đĂ邩H
                        old_SW1 = now_SW1;          // ߋ̋LXV

                        // ωSW1 @uOv({^)H
                        if(!old_SW1){
                            // SW1 Push pX
                            mode++;                 // [htO+1
                            if(mode>2) mode = 0;    // [htOQȏȂ΁A[hOɖ߂
                        }
                    }
                }

                if(old_SW1 != now_SW1){     // SW@ɕω邩H
                    change1 = 1;            // ωtO𗧂āA10msec̎̊ݎɃ`FbN
                }

                now_SW2 = Push_SW2;
                if(change2){
                    change2 = 0;
                    if(old_SW2 != now_SW2){
                        old_SW2 = now_SW2;
                        if(!old_SW2){
                            // SW2 Push pX
                            if(mode == 1){
                               LowerTemp++;
                               if(LowerTemp>UpperTemp) LowerTemp = UpperTemp;
                            }
                            if(mode == 2){
                                UpperTemp++;
                                if(UpperTemp>499) UpperTemp = 499;
                            }
                        }
                    }
                }

                if(old_SW2 != now_SW2){
                    change2 = 1;
                }

                now_SW3 = Push_SW3;
                if(change3){
                    change3 = 0;
                    if(old_SW3 != now_SW3){
                        old_SW3 = now_SW3;
                        if(!old_SW3){
                            // SW3 Push pX
                            if(mode == 1){
                                LowerTemp--;
                                if(LowerTemp<=0) LowerTemp = 0;
                            }
                            if(mode == 2){
                                UpperTemp--;
                                if(UpperTemp<LowerTemp) UpperTemp = LowerTemp;
                            }
                        }
                    }
                }

                if(old_SW3 != now_SW3){
                    change3 = 1;
                }

                now_SW4 = Push_SW4;
                if(change4){
                    change4 = 0;
                    if(old_SW4 != now_SW4){
                        old_SW4 = now_SW4;
                        if(!old_SW4){
                            // SW4 Push pX
                            if(mode != 0){
                                eeprom0 = (unsigned char)(LowerTemp >> 8);
                                eeprom1 = (unsigned char)(LowerTemp & 0x00FF);
                                eeprom2 = (unsigned char)(UpperTemp >> 8);
                                eeprom3 = (unsigned char)(UpperTemp & 0x00FF);
                                E2promWrite(0x00,eeprom0);
                                E2promWrite(0x01,eeprom1);
                                E2promWrite(0x02,eeprom2);
                                E2promWrite(0x03,eeprom3);
                            }
                        }
                    }
                }

                if(old_SW4 != now_SW4){
                    change4 = 1;
                }


                Count--;
		if(Count == 0){
			Count = 100;			// 10msec*100=1sec
			Timer--;
			if(Timer == 0){
				Timer = 10;
			}
		}
	}
}

// ***************************************************************************
// ***************************************************************************
// *																		 *
// ***************************************************************************
// ***************************************************************************

//	Copyright 2012 Ohtan's Design Corporation
